<?php
/**
 * Created by PhpStorm.
 * User: haijun(xu_415@126.com)
 * Date: 2018/1/15
 * Time: 22:11
 */

namespace common\models;

use common\classes\Common;
use Yii;
use yii\db\Exception;

/**
 * Created by PhpStorm.
 * User: haijun(xu_415@126.com)
 * Date: 2017/7/10
 * Time: 23:44
 */
class DeviceConfig extends \yii\base\Model
{
    public $id; //device id
    public $name; //device name
    public $position; //position/description
    public $enable; //enabled
    public $analogBroadcast; //anlog broad cast
    public $prjOn;
    public $prj2On;
    public $pcOn;
    public $micOn;
    public $vgaResolution;
    public $brdTurnoffDelay;
    public $scrnScrollTime;
    public $poweroffDelay;
    public $prjModel;
    public $parityBit;
    public $sendTimes;
    public $sendPeriod;
    public $baudRate;
    public $prjCmdOpen;
    public $prjCmdClose;
    public $prjCmdFromVideo;
    public $prjCmdFromPc;
    public $scrnScrollTime2;
    public $poweroffDelay2;
    public $prjModel2;
    public $parityBit2;
    public $sendTimes2;
    public $sendPeriod2;
    public $baudRate2;
    public $prjCmdOpen2;
    public $prjCmdClose2;
    public $prjCmdFromVideo2;
    public $prjCmdFromPc2;
    public $defaultAvSrc;
    public $prjChannelPc;
    public $prjChannelExtend;
    public $prjChannelPlatform;
    public $prjChannelVideo;
    public $prjChannelPc2;
    public $prjChannelExtend2;
    public $prjChannelPlatform2;
    public $prjChannelVideo2;
    public $defaultAudioVol;
    public $defaultMicVol;
    public $audioVolKeep;
    public $micVolKeep;
    public $audioAmp;
    public $audioBass;
    public $audioTreble;
    public $micAmp;
    public $micBass;
    public $micTreble;
    public $broadVol;

    public $openMode;
    public $innerHdmiAudioOn;
    public $videoEnhanceOn;
    public $micEnhanceOn;
    public $micEnhanceSrc;
    public $mic1EnhanceAmp;
    public $mic2EnhanceAmp;
    public $mic1MagicPowerOn;
    public $mic2MagicPowerOn;
    public $vgaInnerEDID;
    public $rtspUrl;
    public $rtspSub;
    public $rtspUrl1;
    public $rtspSub1;

    public $MaintainQrcode;
    public $pcIp;
    public $pcPort;
    public $pcMainPasswd;
    public $pcViewPasswd;

    public $ProjWatermark;
    public $ProjUsedTime;

    public $configrationV2;
    public $RfInvalid;
    //高级配置标识
    public $optional;
    //外接电脑联动IP、MAC和联动关机标识
    public $externalPcIp;
    public $externalPcMac;
    public $externalPcOff;
    //vlan配置
    public $vlanConfig;                        /*内容为json_encode的字符串，内容形如[['id' => xxx, 'portmask' => yyy, 'trunkport' => 1],[...]], trunkport定义：0 port1, 1 sft;bitmask定义：bit0:sfp, bit1-6:port1-6, bit7:中控，bit8:内置电脑*/
    //中控高级配置
    public $extPwrDelay;                       /*5-65535外接电源关机延时*/
    public $eleLockDelay;                      /*磁控锁开锁延时*/
    public $cp02lcdDelay;                      /*CP02待机熄屏延时*/
    public $clockLinkSys;                      /*1: disable clock when system is disable, 0: enable clock when system is enable. 系统禁用时是否关闭电子钟*/
    public $expPwrLinkBrd;                     /*1: open ext pwr during broadcast, 0: not link ext pwr during broadcast. 广播联动外接电源*/
//    public $rfDevOpenLink;                     /*中控开机联动物联设备bit2-bit15开机*/
//    public $rfDevCloseLink;                    /*中控关机联动物联设备bit2-bit15关机*/
//    public $rfOpenLinkDelay[16];               /*中控开机联动物联设备2-15路开机延时*/
//    public $rfCloseLinkDelay[16];              /*中控关机联动物联设备2-15路关机延时*/
    public $rfDevLink;                         //物联设备联动配置json_encode字符串，内容形如[['id' => 0, 'open' => 1, 'close'=>1, 'openDelay' => xxx, 'closeDelay'=>yyy], [...]]
    public $lcdSrc;                            /*默认显示器输入，1为电脑，2为笔记本，3为展台*/
    public $cp02PrjCtrl;                       /*CP02显示投影机个数，0为单投影，1为双投影*/
    public $icPowerOffDelay;                   /*IC卡插卡模式拨卡关机延时*/
    public $recSupport;                        /*常态化录播支持选项，0不支持，1支持*/
    public $dftPgmChn;                         /*默认录播通道0-4，默认0*/
    public $audSwitchEnFlag;                   /*使能音频广播切换盒*/
    public $linkPwrType;                       /*外部联动开机方式：0：常闭型开机，1：常开型开机*/
    public $elelockLevel;                      /*磁控开锁电平选择：0：高电平，1：低电平*/
    public $igmpVer;                           /*IGMP版本支持：0：IGMPv3，1：IGMPv2*/
    public $ampType;                           /*功放选择：0：内置， 1：外置*/
    public function rules()
    {
        return [
            [['id'], 'required'],
            [['defaultAvSrc', 'openMode', 'vgaResolution', 'prjOn', 'prj2On', 'pcOn', 'micOn', 'enable',
                'analogBroadcast', 'innerHdmiAudioOn', 'videoEnhanceOn', 'micEnhanceOn', 'mic1EnhanceAmp', 'mic2EnhanceAmp'], 'required'],  //system config
            [['defaultAudioVol', 'defaultMicVol', 'audioAmp', 'audioBass', 'audioTreble', 'micAmp', 'micBass', 'micTreble', 'broadVol', 'audioVolKeep', 'micVolKeep'], 'required'], //audio config
            [['prjChannelPc', 'prjChannelExtend', 'prjChannelPlatform', 'prjChannelVideo', 'parityBit', 'sendTimes', 'sendPeriod',
                'baudRate', 'scrnScrollTime', 'poweroffDelay'], 'required'], //video config
            [['prjCmdOpen', 'prjCmdClose', 'prjCmdFromVideo', 'prjCmdFromPc', 'prjModel'], 'string',],
            [['prjCmdOpen2', 'prjCmdClose2', 'prjCmdFromVideo2', 'prjCmdFromPc2', 'prjModel2'], 'string',],
            [['prjCmdOpen', 'prjCmdClose', 'prjCmdFromVideo', 'prjCmdFromPc'], 'match', 'pattern' => '/^[0-9A-F]*$/i'],
            [['prjCmdOpen2', 'prjCmdClose2', 'prjCmdFromVideo2', 'prjCmdFromPc2'], 'match', 'pattern' => '/^[0-9A-F]*$/i'],
            [['name', 'position'], 'string', 'max' => 96],
            [['prjModel'], 'string', 'max' => 64],
            [['name', 'position'], 'trim'],
            ['pcIp', 'ip'],
            ['pcPort', 'integer', 'max' => 65535, 'min' => 1],
            ['optional', 'integer', 'max' => 65535, 'min' => 0],
            [['pcMainPasswd', 'pcViewPasswd'], 'string', 'max' => 32],
            [['brdTurnoffDelay', 'scrnScrollTime', 'poweroffDelay'], 'integer'],
            [['scrnScrollTime2', 'poweroffDelay2'], 'integer'],
            [['prjOn', 'pcOn', 'micOn', 'enable', 'analogBroadcast', 'innerHdmiAudioOn', 'videoEnhanceOn', 'micEnhanceOn', 'mic1MagicPowerOn', 'mic2MagicPowerOn',
                'prjChannelPc', 'prjChannelExtend', 'prjChannelPlatform', 'prjChannelVideo', 'audioVolKeep', 'micVolKeep', 'vgaInnerEDID'], 'integer', 'max' => 1, 'min' => 0],
            [['prjChannelPc2', 'prjChannelExtend2', 'prjChannelPlatform2', 'prjChannelVideo2'], 'integer', 'max' => 1, 'min' => 0],
            [['openMode', 'audioAmp', 'micAmp', 'defaultAvSrc', 'sendTimes', 'sendPeriod', 'micEnhanceSrc'], 'integer', 'max' => 3, 'min' => 0],
            [['sendTimes2', 'sendPeriod2'], 'integer', 'max' => 3, 'min' => 0],
            [['baudRate2'], 'integer', 'max' => 11, 'min' => 0],
            [['vgaResolution', 'mic1EnhanceAmp', 'mic2EnhanceAmp'], 'integer', 'max' => 7, 'min' => 0],
            [['parityBit'], 'integer', 'max' => 2, 'min' => 0],
            [['parityBit2'], 'integer', 'max' => 2, 'min' => 0],
            [['defaultAudioVol', 'defaultMicVol', 'broadVol'], 'integer', 'max' => 64, 'min' => 0],
            [['audioBass', 'audioTreble', 'micBass', 'micTreble'], 'integer', 'max' => 15, 'min' => 0],
            [['rtspUrl', 'rtspSub', 'rtspUrl1', 'rtspSub1'], 'string', 'max' => 128],  //camera config
            [['rtspUrl', 'rtspSub', 'rtspUrl1', 'rtspSub1'], 'match', 'pattern' => '/^rtsp:\/\//i'],  //camera config
            [['ProjWatermark', 'ProjUsedTime', 'RfInvalid'], 'integer', 'min' => 0],
            [['vlanConfig'], 'string', 'max' => 256],
            [['rfDevLink'], 'string', 'max' => 1024],
            [['externalPcIp'], 'string', 'max' => 32],
            [['externalPcMac'], 'string', 'max' => 32],
            [['externalPcOff', 'clockLinkSys','expPwrLinkBrd','lcdSrc', 'cp02lcdDelay','cp02PrjCtrl','recSupport','dftPgmChn', 'audSwitchEnFlag'], 'integer', 'min' => 0, 'max' => 255],
            [['linkPwrType', 'elelockLevel','igmpVer','ampType'], 'integer', 'min' => 0, 'max' => 255],
            [['optional', 'extPwrDelay', 'eleLockDelay', 'icPowerOffDelay'], 'integer', 'max' => 65536, 'min' => 0],
        ];
    }

    public function load($data, $formName = null)
    {
        $ret = parent::load($data, $formName); // TODO: Change the autogenerated stub
        if($ret === false)
            return $ret;
        $this->name = mb_strcut($this->name, 0, 32);
        return $this->validate();
    }

    public function save(){
        if(!preg_match('/^[0-9][0-9,]+[0-9]$/', $this->id))
            return false;
        //读取设备配置
        Yii::$app->db->createCommand("select device_ctrl(IpAddress, DeviceID, 55, 1, 0, 0) from DeviceStatus where DeviceID in ($this->id);")->execute();
        usleep(1000000);
        $ids = explode(',', $this->id);
        if(empty($ids))
            return false;
        $config = $this->formatConfig($has_opt4);
        foreach($ids as $id){
            $vdevice = VDevice::findOne(['id' => $id]);
            $device = DeviceList::findOne(['DevID' => $id]);

            if (empty($this->rtspUrl))
                $device->RtspUrl = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspUrl))
                $device->RtspUrl = $this->rtspUrl;
            if (empty($this->rtspSub))
                $device->RtspSub = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspSub))
                $device->RtspSub = $this->rtspSub;
            if (empty($this->rtspUrl1))
                $device->RtspUrl1 = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspUrl1))
                $device->RtspUrl1 = $this->rtspUrl1;
            if (empty($this->rtspSub1))
                $device->RtspSub1 = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspSub1))
                $device->RtspSub1 = $this->rtspSub1;
            if(isset($this->RfInvalid) && is_numeric($this->RfInvalid))
                $device->RfInvalid = $this->RfInvalid;

            if(is_null($vdevice) || is_null($device))
                continue;
            if ($device->ProjWatermark != $this->ProjWatermark || $device->ProjUsedTime != $this->ProjUsedTime) {
                $device->ProjUsedTime = $this->ProjUsedTime;
                $device->ProjWatermark = $this-> ProjWatermark;
                $device->save();
            }
            if($has_opt4) {
                if ($this->getDeviceOptionalConfigOld($device, $opt1, $opt2, $opt3, $opt4) && $opt4)
                    $new_config = $config . bin2hex(substr($opt4, 55, 201));
                else
                    $new_config = $config . $this->formatString('00', 201 * 2, true, false);
            }
            else
                $new_config = $config;
            $tmp = bin2hex($device->Dev_Configuration);
            if(count($ids) > 1){
                $realCfg = substr($tmp, 0, 256) . substr($new_config, 256);
                $sql = "call sp_send_dev_cfg_cmd('" . $vdevice->id . "', '" . $vdevice->ipaddress . "','" . $realCfg . "','','');";
            }
            else
                $sql = "call sp_send_dev_cfg_cmd('" . $vdevice->id . "', '" . $vdevice->ipaddress . "','" . $new_config . "','','');";
            Yii::$app->getDb()->createCommand($sql)->execute();
        }

        if(count($ids) == 1 && !is_null($vdevice) && !is_null($device)){
            $device->Dev_Description = iconv('UTF-8', 'GBK', $this->position);
            $device->Dev_Name = $this->name;

            if($this->pcMainPasswd !== '***')
                $device->PcMainPasswd = $this->pcMainPasswd;
            if($this->pcViewPasswd !== '***')
                $device->PcViewPasswd = $this->pcViewPasswd;
            $device->PcIp = $this->pcIp;
            $device->PcPort = $this->pcPort;
            return $device->save();
        }
        return true;
    }

    private function formatInt($value, $bytes) {
        $ret = '';
        for ($j = 0; $j < 8 * $bytes; $j += 8) {
            $val = ($value >> $j) % 256;
            $ret .= sprintf("%02x", $val);
        }
        return $ret;
    }
    private function formatString($str, $bytes, $padding = true, $bin2hex = true) {
        if($bin2hex)
            $ret =  bin2hex(substr($str, 0, $bytes));
        else
            $ret = substr($str, 0, $bytes);
        if($padding) {
            $step = $bin2hex ? 1:2;
            for ($j = strlen($str); $j < $bytes; $j += $step)
                $ret .= '00';
        }
        return $ret;
    }

    static function readInt($value, $bytes, &$i) {
        $ret = 0;
        for($j = 0; $j < $bytes * 8; $j += 8)
            $ret += hexdec(bin2hex($value[$i++])) << $j;
        return $ret;
    }

    /**
     * @param $device DeviceList
     * @param $opt1
     * @param $opt2
     * @param $opt3
     * @param $opt4
     * @return bool
     */
    private function getDeviceOptionalConfigOld($device, &$opt1, &$opt2, &$opt3, &$opt4) {
        $opt1 = $opt2 = $opt3 = $opt4 = null;
        if (!$device && substr($device->DevID, 0, 1) === '5')
            return false;
        $config = $device->Dev_Configuration;
        if(strlen($config) <= 480)
            return false;
        $opt1 = substr($config, 0, 480);
        /*480之后为高级配置*/
        $i = 480;
        $optional = self::readInt($config, 2, $i);
        // 第二路投影机配置
        if ($optional & 0x01) {
            if(strlen($config) < $i + 334)
                return false;
            $opt2 = substr($config, $i, 334);
            $i += 334;
        }
        if($optional & 0x02) {
            if(strlen($config) < $i + 66)
                return false;
            $opt2 = substr($config, $i, 66);
            $i += 66;
        }
        if($optional & 0x04){
            if(strlen($config) < $i + 1)
                return false;
            $sum = self::readInt($config, 1, $i);
            if(strlen($config) < $i + $sum * 4)
                return false;
            $opt3 = substr($config, $i - 1, 2 + $sum * 4);
            $i += $sum * 4 + 1;
        }
        if($optional & 0x08){
            if(strlen($config) < $i + 256)
                return false;
            $opt4 = substr($config, $i, 256);
        }
        return true;
    }

    private function formatConfig(&$has_opt4)
    {
        $has_opt4 = false;
        $name = bin2hex(iconv('UTF-8', 'GBK', mb_strcut($this->name, 0, 32)));
        $configArr = $name;
        for ($i = strlen($name); $i < 64; $i += 2)
            $configArr .= '00';
        $position = bin2hex(iconv('UTF-8', 'GBK', mb_strcut($this->position, 0, 96)));
        $configArr .= $position;
        for ($i = strlen($position); $i < 192; $i += 2)
            $configArr.= '00';
        //position 128
        $val = ($this->openMode << 4) + $this->enable;
        $configArr .= sprintf("%02x", $val);

        $val = $this->analogBroadcast & 1;
        $val += ($this->mic1EnhanceAmp & 0x07) <<2;
        $val += ($this->mic2EnhanceAmp & 0x07) <<5;
        $configArr .= sprintf("%02x", $val);
        $val = ($this->prjOn & 1) << 4;
        $val += ($this->pcOn & 1) << 5;
        $val += ($this->micOn & 1) << 6;
        $val += ($this->prj2On & 1) << 7;
        $configArr .= sprintf("%02x", $val);
        $configArr .= sprintf("%02x", $this->vgaResolution);

        //position 132;
        $configArr .= $this->formatInt($this->brdTurnoffDelay, 4);
        $configArr .= $this->formatInt($this->scrnScrollTime, 4);
        $configArr .= $this->formatInt($this->poweroffDelay, 4);
        $mod = bin2hex(iconv('UTF-8', 'GBK', mb_strcut($this->prjModel, 0, 64)));
        $configArr .= $mod;
        for ($j = strlen($mod); $j < 128; $j += 2)
            $configArr .= '00';

        //position 208 proj_cmd_t
        $configArr .= sprintf("%02x", $this->parityBit);
        $configArr .= sprintf("%02x", $this->sendTimes);
        $configArr .= sprintf("%02x", $this->sendPeriod);
        $configArr .= sprintf("%02x", $this->baudRate);
        $len = strlen($this->prjCmdOpen) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->prjCmdOpen;
        for ($j = strlen($this->prjCmdOpen); $j < 126; $j += 2)
            $configArr .= '00';
        $len = strlen($this->prjCmdClose) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->prjCmdClose;
        for ($j = strlen($this->prjCmdClose); $j < 126; $j += 2)
            $configArr .= '00';
        $len = strlen($this->prjCmdFromVideo) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->prjCmdFromVideo;
        for ($j = strlen($this->prjCmdFromVideo); $j < 126; $j += 2)
            $configArr .= '00';
        $len = strlen($this->prjCmdFromPc) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->prjCmdFromPc;
        for ($j = strlen($this->prjCmdFromPc); $j < 126; $j += 2)
            $configArr .= '00';
        //position 468
        if($this->audioVolKeep === 1)
            $this->defaultAudioVol = 255;
        if($this->micVolKeep == 1)
            $this->defaultMicVol = 255;
        $configArr .= sprintf("%02x", $this->defaultAudioVol);

        $configArr .= sprintf("%02x", $this->defaultMicVol);
        // position 470;
        $configArr .= sprintf("%02x", $this->defaultAvSrc);
        $val = $this->prjChannelPc & 3;
        $val += ($this->prjChannelExtend & 3) << 2;
        $val += ($this->prjChannelPlatform & 3) << 4;
        $val += ($this->prjChannelVideo & 3) << 6;
        $configArr .= sprintf("%02x", $val);
        $configArr .= sprintf("%02x", $this->audioAmp);
        $configArr .= sprintf("%02x", $this->audioBass);
        $configArr .= sprintf("%02x", $this->audioTreble);
        $configArr .= sprintf("%02x", $this->micAmp);
        $configArr .= sprintf("%02x", $this->micBass);
        $configArr .= sprintf("%02x", $this->micTreble);
        $configArr .= sprintf("%02x", $this->broadVol);

        //position 479
        $val = ($this->innerHdmiAudioOn ^ 1) & 1;;
        $val += ($this->videoEnhanceOn & 1) << 1;
        $val += ($this->micEnhanceOn & 1) << 2;
        $val += ($this->micEnhanceSrc & 3) << 5;
        $val += ($this->mic1MagicPowerOn & 1) << 3;
        $val += ($this->mic2MagicPowerOn & 1) << 4;
        $val += ($this->vgaInnerEDID & 1) << 7;
        $configArr .= sprintf("%02x", $val);

        $configArr .= $this->formatInt($this->optional, 2);
        Yii::$app->base->baseGet(Common::BASEINFO_SECOND_PROJECTOR_SUPPORT, $des, $val);
        if($val !== 1)
            $this->prjModel2 = '';
        if ($this->optional & 1) {
            //第二路投影什么配置
            $configArr .= $this->formatInt($this->scrnScrollTime2, 4);
            $configArr .= $this->formatInt($this->poweroffDelay2, 4);
            $mod = iconv('UTF-8', 'GBK', mb_strcut($this->prjModel2, 0, 64));
            $configArr .= $this->formatString($mod, 64);
            $configArr .= $this->formatInt($this->parityBit2, 1);
            $configArr .= $this->formatInt($this->sendTimes2, 1);
            $configArr .= $this->formatInt($this->sendPeriod2, 1);
            $configArr .= $this->formatInt($this->baudRate2, 1);
            $configArr .= $this->formatInt(strlen($this->prjCmdOpen2) >> 1, 1);
            $configArr .= $this->formatString($this->prjCmdOpen2, 126, true, false);
            $configArr .= $this->formatInt(strlen($this->prjCmdClose2) >> 1, 1);
            $configArr .= $this->formatString($this->prjCmdClose2, 126, true, false);
            $configArr .= $this->formatInt(strlen($this->prjCmdFromVideo2) >> 1, 1);
            $configArr .= $this->formatString($this->prjCmdFromVideo2, 126, true, false);
            $configArr .= $this->formatInt(strlen($this->prjCmdFromPc2) >> 1, 1);
            $configArr .= $this->formatString($this->prjCmdFromPc2, 126, true, false);
            $val = $this->prjChannelPc & 3;
            $val += ($this->prjChannelExtend & 3) << 2;
            $val += ($this->prjChannelPlatform & 3) << 4;
            $val += ($this->prjChannelVideo & 3) << 6;
            $configArr .= $this->formatInt($val, 1);
            $configArr .= $this->formatInt(0, 1);
        }
        if($this->optional & 2) {
            $configArr .= $this->formatString($this->externalPcIp, 32);
            $configArr .= $this->formatString($this->externalPcMac, 32);
            $configArr .= $this->formatInt($this->externalPcOff, 1);
            $configArr .= '00';
        }
        if($this->optional & 4) {
            $cfg = json_decode($this->vlanConfig, true);
            if(!empty($cfg)) {
                $configArr .= $this->formatInt(count($cfg['config']), 1);
                $configArr .= $this->formatInt($cfg['trunkport'], 1);
                foreach ($cfg['config'] as $c) {
                    $configArr .= $this->formatInt($c['id'], 2);
                    $configArr .= $this->formatInt($c['portmask'], 2);
                }
            }
        }
        if($this->optional & 8) {
            $configArr .= $this->formatInt($this->extPwrDelay, 2);
            $configArr .= $this->formatInt($this->eleLockDelay, 2);
            $configArr .= $this->formatInt($this->cp02lcdDelay, 2);
            $configArr .= $this->formatInt($this->clockLinkSys, 1);
            $configArr .= $this->formatInt($this->expPwrLinkBrd, 1);
            //RF
            $cfg = json_decode($this->rfDevLink, true);
            $open = 0;
            $close = 0;
            $openDelay = [];
            $closeDelay = [];
            for($j = 0; $j <16; $j++) {
                $openDelay[] = '00';
                $closeDelay[] = '00';
            }
            if(!empty($cfg) && is_array($cfg)) {
                foreach ($cfg as $c) {
                    if(!array_key_exists('id', $c) || !is_numeric($c['id']) || $c['id'] < 0 || $c['id'] > 16)
                        continue;
                    if($c['open']) {
                        $open += (1 << $c['id']);
                        $openDelay[$c['id']] = $this->formatInt($c['openDelay'], 1);
                    }
                    if($c['close']) {
                        $close += (1 << $c['id']);
                        $closeDelay[$c['id']] = $this->formatInt($c['closeDelay'], 1);
                    }
                }
            }
            $configArr .= $this->formatInt($open, 2);
            $configArr .= $this->formatInt($close, 2);
            $configArr .= implode('', $openDelay);
            $configArr .= implode('', $closeDelay);
            $configArr .= $this->formatInt($this->lcdSrc, 1);
            $configArr .= $this->formatInt($this->cp02PrjCtrl, 1);
            $configArr .= $this->formatInt($this->icPowerOffDelay, 2);
            $configArr .= $this->formatInt($this->recSupport, 1);
            $configArr .= $this->formatInt($this->dftPgmChn, 1);
            $configArr .= $this->formatInt($this->audSwitchEnFlag, 1);
            $configArr .= $this->formatInt($this->linkPwrType, 1);
            $configArr .= $this->formatInt($this->elelockLevel, 1);
            $configArr .= $this->formatInt($this->igmpVer, 1);
            $configArr .= $this->formatInt($this->ampType, 1);
            $has_opt4 = true;
        }
        return $configArr;
    }

    public static function readConfig($id)
    {
        $device = DeviceList::findOne(['DevID' => $id]);
        if (is_null($device))
            return NULL;
        $dev_cfg = null;
        if (substr($id, 0, 1) === '5') {
            $dev_cfg = $device->Dev_ConfigurationV2;
            $device->Dev_ConfigurationV2 = NULL;
        } else {
            $dev_cfg = $device->Dev_Configuration;
            $device->Dev_Configuration = NULL;
        }
        $device->save();
        $cnt = 10;
        while($cnt > 0) {
            Yii::$app->db->createCommand("select device_ctrl(IpAddress, '$id', 55, 1, 0, 0) from DeviceStatus where DeviceID='$id';")->execute();
            usleep(200000);
            $device = DeviceList::findOne(['DevID' => $id]);
            if (!is_null($device)) {
                if (substr($id, 0, 1) === '5') {
                    if (!is_null($device->Dev_ConfigurationV2))
                        break;
                } else {
                    if (!is_null($device->Dev_Configuration))
                        break;
                }
            }
            $cnt--;
        }
        if($cnt == 0) {
            if(!empty($device)) {
                if (substr($id, 0, 1) === '5') {
                    $device->Dev_ConfigurationV2 = $dev_cfg;
                } else {
                    $device->Dev_Configuration = $dev_cfg;
                }
                $device->save();
            }
            return null;
        }
        $config = new DeviceConfig();
        $config->id = $device->DevID;
        $config->rtspUrl = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspUrl);
        $config->rtspUrl1 = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspUrl1);
        $config->rtspSub = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspSub);
        $config->rtspSub1 = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspSub1);
        $config->ProjWatermark = $device->ProjWatermark;
        $config->ProjUsedTime = $device->ProjUsedTime;
        $uuid = Yii::$app->base->uuid;
        $identify = "u=$uuid&i=" . $device->DevID;
        $config->MaintainQrcode = 'https://' . Yii::$app->base->getCloudServer() . "/s/oq?$identify";
        $config->pcIp = $device->PcIp;
        $config->pcPort = $device->PcPort;
        $config->pcMainPasswd = empty($device->PcMainPasswd) ? "" : "***";
        $config->pcViewPasswd = empty($device->PcViewPasswd) ? "" : "***";
        $config->RfInvalid = isset($device->RfInvalid) ? $device->RfInvalid : 0;
        if (substr($id, 0, 1) === '5') {
            $config->setScenario('v2');
            $confV2 = str_replace(["\n", ",}", ',]'], ['', '}', ']'], $device->Dev_ConfigurationV2);
            $config->configrationV2 = json_decode($confV2);
            $config->position = iconv('GBK', 'UTF-8', $device->Dev_Description);
            return $config;
        }
        if(empty($device->Dev_Configuration) || strlen($device->Dev_Configuration) < 480)
            return $config;
        $configArr = $device->Dev_Configuration;
        //0-131共132字节为设备配置字段
        for ($i = 0; $i < 32; $i++) {
            if (bin2hex($configArr[$i]) == '00')
                break;
        }
        $config->name = iconv('GBK', 'UTF-8', substr($configArr, 0, $i));
        if (is_null($config->name))
            $config->name = $device->Dev_Name;
        for ($i = 32; $i < 128; $i++) {
            if (bin2hex($configArr[$i]) == '00')
                break;
        }
        $config->position = iconv('GBK', 'UTF-8', substr($configArr, 32, $i - 32));
        if (is_null($config->position))
            $config->position= $device->Dev_Description;
        $i = 128;
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->enable = $val & 0x0f;
        $config->openMode = ($val >> 4);
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->analogBroadcast = $val & 0x01;
        $config->mic1EnhanceAmp = ($val >> 2) & 0x07;
        $config->mic2EnhanceAmp = ($val >> 5) & 0x07;
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->prjOn = ($val >> 4) & 0x01;
        $config->pcOn = ($val >> 5) & 0x01;
        $config->micOn = ($val >> 6) & 0x01;
        $config->prj2On = ($val >> 7) & 0x01;
        $config->vgaResolution = hexdec(bin2hex($configArr[$i++]));
        $i = 132;
        //132-467共336字节为视频配置字段
        $config->brdTurnoffDelay = self::readInt($configArr, 4, $i);
        $config->scrnScrollTime = self::readInt($configArr, 4, $i);
        $config->poweroffDelay = self::readInt($configArr, 4, $i);
        for ($j = 0; $j < 64; $j++) {
            if (bin2hex($configArr[$i + $j]) == '00')
                break;
        }
        $config->prjModel = iconv('GBK', 'UTF-8', substr($configArr, $i, $j));
        $i += 64;
        $config->parityBit = hexdec(bin2hex($configArr[$i++]));
        $config->sendTimes = hexdec(bin2hex($configArr[$i++]));
        $config->sendPeriod = hexdec(bin2hex($configArr[$i++]));
        $config->baudRate = hexdec(bin2hex($configArr[$i++]));
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->prjCmdOpen = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i += 63;
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->prjCmdClose = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i += 63;
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->prjCmdFromVideo = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i += 63;
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->prjCmdFromPc = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i = 468;
        //468-478为音频配置字段
        $config->defaultAudioVol = hexdec(bin2hex($configArr[$i++]));
        $config->defaultMicVol = hexdec(bin2hex($configArr[$i++]));
        if ($config->defaultAudioVol > 63) {
            $config->audioVolKeep = 1;
            $config->defaultAudioVol = 0;
        } else {
            $config->audioVolKeep = 0;
        }
        if ($config->defaultMicVol > 63) {
            $config->micVolKeep = 1;
            $config->defaultMicVol = 0;
        } else {
            $config->micVolKeep = 0;
        }
        $config->defaultAvSrc = hexdec(bin2hex($configArr[$i++]));
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->prjChannelPc = $val & 0x01;
        $config->prjChannelExtend = ($val >> 2) & 0x03;
        $config->prjChannelPlatform = ($val >> 4) & 0x03;
        $config->prjChannelVideo = ($val >> 6) & 0x03;
        $config->audioAmp = hexdec(bin2hex($configArr[$i++]));
        $config->audioBass = hexdec(bin2hex($configArr[$i++]));
        $config->audioTreble = hexdec(bin2hex($configArr[$i++]));
        $config->micAmp = hexdec(bin2hex($configArr[$i++]));
        $config->micBass = hexdec(bin2hex($configArr[$i++]));
        $config->micTreble = hexdec(bin2hex($configArr[$i++]));
        $config->broadVol = hexdec(bin2hex($configArr[$i++]));
        $i = 479;
        //479为设备配置字段
        $val = hexdec(bin2hex($configArr[$i]));
        $config->innerHdmiAudioOn = ($val ^ 1) & 0x01;
        $config->videoEnhanceOn = ($val >> 1) & 0x01;
        $config->micEnhanceOn = ($val >> 2) & 0x01;
        $config->micEnhanceSrc = ($val >> 5) & 0x03;
        $config->mic1MagicPowerOn = ($val >> 3) & 0x01;
        $config->mic2MagicPowerOn = ($val >> 4) & 0x01;
        $config->vgaInnerEDID = ($val >> 7) & 0x01;
        $i++;
        if (strlen($configArr) <= 480) {
            $config->optional  = 0;
            // tm-03
            $config->configrationV2 = $device->Dev_ConfigurationV2;
            return $config;
        }
        /*480之后为高级配置*/
        $config->optional = self::readInt($configArr, 2, $i);
        do {
            // 第二路投影机配置
            if ($config->optional & 0x01) {
                if(strlen($configArr) < $i + 334)
                    break;
                $config->scrnScrollTime2 = self::readInt($configArr, 4, $i);
                $config->poweroffDelay2 = self::readInt($configArr, 4, $i);
                for ($j = 0; $j < 64; $j++) {
                    if (bin2hex($configArr[$i + $j]) == '00')
                        break;
                }
                $config->prjModel2 = trim(iconv('GBK', 'UTF-8', substr($configArr, $i, $j)));
                $i += 64;
                $config->parityBit2 = self::readInt($configArr, 1, $i);
                $config->sendTimes2 = self::readInt($configArr, 1, $i);
                $config->sendPeriod2 = self::readInt($configArr, 1, $i);
                $config->baudRate2 = self::readInt($configArr, 1, $i);
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->prjCmdOpen2 = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->prjCmdClose2 = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->prjCmdFromVideo2 = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->prjCmdFromPc2 = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $val = self::readInt($configArr, 1, $i);
                $config->prjChannelPc2 = 0;
                $config->prjChannelExtend2 = 0;
                $config->prjChannelPlatform2 = 0;
                $config->prjChannelVideo2 = 0;
                $i++;
            }
            if($config->optional & 0x02) {
                if(strlen($configArr) < $i + 66)
                    break;
                $config->externalPcIp = trim(substr($configArr, $i, 32));
                $i += 32;
                $config->externalPcMac =  trim(substr($configArr, $i, 32));
                $i += 32;
                $config->externalPcOff = (hexdec(bin2hex($configArr[$i++])) & 1);
                $i++;
            }
            if($config->optional & 0x04){
                if(strlen($configArr) < $i + 1)
                    break;
                $sum = self::readInt($configArr, 1, $i);
                if(strlen($configArr) < $i + $sum * 4)
                    break;
                $cfg = [];
                $trunkport = self::readInt($configArr, 1, $i);
                for($j = 0; $j < $sum; $j++) {
                    $id = self::readInt($configArr, 2, $i);
                    $portmask = self::readInt($configArr, 2, $i);
                    $cfg[] = ['id' => $id, 'portmask' => $portmask];
                }
                $config->vlanConfig = json_encode(['num' => $sum, 'trunkport' => $trunkport, 'config' => $cfg]);
            }
            if($config->optional & 0x08){
                if(strlen($configArr) < $i + 256)
                    break;
                $config->extPwrDelay = self::readInt($configArr, 2, $i);
                $config->eleLockDelay = self::readInt($configArr, 2, $i);
                $config->cp02lcdDelay = self::readInt($configArr, 2, $i);
                $config->clockLinkSys = self::readInt($configArr, 1, $i);
                $config->expPwrLinkBrd = self::readInt($configArr, 1, $i);
                $rfDevOpenLink = self::readInt($configArr, 2, $i);
                $rfDevCloseLink = self::readInt($configArr, 2, $i);
                $cfg = [];
                for($j = 0; $j < 16; $j++) {
                    $openDelay = hexdec(bin2hex($configArr[$i]));
                    $closeDelay = hexdec(bin2hex($configArr[$i++ + 16]));
                    $open = (($rfDevOpenLink >> $j) & 1);
                    $close = (($rfDevCloseLink >> $j) & 1);
                    $cfg[] = [
                        'id' => $j,
                        'open' => $open,
                        'close' => $close,
                        'openDelay' => $openDelay,
                        'closeDelay' => $closeDelay
                    ];
                }
                $i += 16;
                $config->rfDevLink = json_encode($cfg);
                $config->lcdSrc = self::readInt($configArr, 1, $i);
                $config->cp02PrjCtrl = self::readInt($configArr, 1, $i);
                $config->icPowerOffDelay = self::readInt($configArr, 2, $i);
                $config->recSupport = self::readInt($configArr, 1, $i);
                $config->dftPgmChn = self::readInt($configArr, 1, $i);
                $config->audSwitchEnFlag = self::readInt($configArr, 1, $i);
                $config->linkPwrType = self::readInt($configArr, 1, $i);
                $config->elelockLevel = self::readInt($configArr, 1, $i);
                $config->igmpVer = self::readInt($configArr, 1, $i);
                $config->ampType = self::readInt($configArr, 1, $i);
            }
        }while(false);

        // tm-03
        $config->configrationV2 = $device->Dev_ConfigurationV2;
        return $config;
    }

    public function fields()
    {
        if ($this->getScenario() == 'v2')
            return ['MaintainQrcode', 'configrationV2', 'ProjUsedTime', 'ProjWatermark', 'id', 'name', 'position',
                'pcIp', 'pcMainPasswd', 'pcPort', 'pcViewPasswd',
                'rtspUrl', 'rtspUrl1', 'rtspSub', 'rtspSub1', 'RfInvalid'];
        else {
            $fields = parent::fields(); // TODO: Change the autogenerated stub
            unset($fields['configrationV2']);
            return $fields;
        }
    }
}
